/*
 * I2Cڑt AQUM0802A-RN-GBW̕\ƃRgXgTv@Version 1.00
 * File:        lcd1c.c
 * Target:      PIC18F46K22 64MHz
 * RpC:   Microchip MPLAB XC8 C Compiler V1.20
 * :     PICKit 3
 * [X:     2014/01/25 14:00
 * \(2sڂ26݂͌̃RgXgl\ Tvł20?40܂ŎIɕω)
 *   AQUM0802A
 *   CONT   26
 * gp[q
 *   SCK1(RC3),SDA1(RC4)
*/

#include <stdio.h>
#include <stdlib.h>
#include <p18f46k22.h>
#include <plib\delays.h>
#include <plib\i2c.h>

#pragma config  FOSC = HSHP,PRICLKEN=ON,PLLCFG=ON,WDTEN=OFF,LVP=OFF

#define LED0 PORTBbits.RB5
#define LCD_SADS 0x7c   //  t̃X[uAhX
#define LCD_RSDATA  0x40
#define LCD_RSCMD  0x0
#define LCD_C01  0x80
#define LCD_C00  0x80
#define lcd_putc(c) lcd_data(c) // LCD1o

signed char i2c_write(unsigned char d); // i2c1byteM
void lcd_cmd(unsigned char cmd); //  LCDփR}h1byteM
void lcd_clear(void); //  LCDNA
void lcd_init(void); //  LCD
void lcd_cont(unsigned char c); //  LCDRgXgύX(0?63)
void lcd_data(unsigned char c); //  LCDփf[^1byteM
void lcd_ddram(unsigned char ads); //  LCD̕\AhXݒ
void lcd_puts(const char* buf); //  LCDɕ\

void main(void) {
    char buf[4];
    ANSELCbits.ANSC3=0;
    ANSELCbits.ANSC4=0;

    Delay10KTCYx( 64);  //  40ms/(64MHz/4)=  640000

    OpenI2C(MASTER,SLEW_ON);    // }X^[
    SSPADD=39;  //  400kHz

    lcd_init();
    lcd_puts("AQM0802A\nCont");

    unsigned char c;    //  RgXg
    for(;;){
        for(c=20;c<40;c++){
            sprintf(buf,"%.2i",(int)c);
            lcd_ddram(6);
            lcd_puts(buf);
            lcd_cont(c);
            Delay10KTCYx( 255);
        }
        for(;20<=c;c--){
            sprintf(buf,"%.2i",(int)c);
            lcd_ddram(6);
            lcd_puts(buf);
            lcd_cont(c);
            Delay10KTCYx( 255);
        }
    }
}

// i2c1byteM

signed char i2c_write(unsigned char d){
    signed char ret;
    ret=WriteI2C(d);
    IdleI2C();
    return ret;
}

//  LCDփR}h1byteM

void lcd_cmd(unsigned char cmd){
    SSPCON1bits.WCOL=0;
    IdleI2C();
    StartI2C();
    while(SSPCON2bits.SEN);
    i2c_write( LCD_SADS);
    i2c_write( LCD_RSCMD | LCD_C01 );
    i2c_write(cmd);
    StopI2C();
    while(SSPCON2bits.PEN);
}

//  LCDNA

void lcd_clear(void){
    lcd_cmd(0x01);    //  Clear Display
    Delay1KTCYx( 17);  //  1.06ms/(64MHz/4)=  17000
}

//  LCD

void lcd_init(void){
    lcd_cmd(0x38);    //  Function Set
    Delay10TCYx( 43);  //  26.3s/(64MHz/4)=  430
    lcd_cmd(0x39);    //  Function Set
    Delay10TCYx( 43);  //  26.3s/(64MHz/4)=  430
    lcd_cmd(0x14);    //  Internal OSC frequency
    Delay10TCYx( 43);  //  26.3s/(64MHz/4)=  430
    lcd_cmd(0x73);    //  Contrast set
    Delay10TCYx( 43);  //  26.3s/(64MHz/4)=  430
    lcd_cmd(0x56);    //  Power/ICON/Contrast control
    Delay10TCYx( 43);  //  26.3s/(64MHz/4)=  430
    lcd_cmd(0x6c);    //  Follower control
    Delay10KTCYx( 160);  //  100ms/(64MHz/4)=  1600000
    Delay10KTCYx( 160);  //  100ms/(64MHz/4)=  1600000
    lcd_cmd(0x38);    //  Function Set
    Delay10TCYx( 43);  //  26.3s/(64MHz/4)=  430
    lcd_cmd(0x0c);    //  Display On/Off
    Delay10TCYx( 43);  //  26.3s/(64MHz/4)=  430
    lcd_clear();
}

//  LCDRgXgύX(0?63)

void lcd_cont(unsigned char c){
    lcd_cmd(0x39);    //  Function Set
    Delay10TCYx( 43);  //  26.3s/(64MHz/4)=  430
    lcd_cmd(0x70 | c);    //  Contrast set
    Delay10TCYx( 43);  //  26.3s/(64MHz/4)=  430
    lcd_cmd(0x54 | (c>>4));    //  Power/ICON/Contrast control
    Delay10TCYx( 43);  //  26.3s/(64MHz/4)=  430

}

//  LCDփf[^1byteM

void lcd_data(unsigned char c){
    SSPCON1bits.WCOL=0;
    IdleI2C();
    StartI2C();
    while(SSPCON2bits.SEN);
    i2c_write(LCD_SADS);
    i2c_write( LCD_RSDATA | (LCD_C01) );
    i2c_write(c);
    StopI2C();
    while(SSPCON2bits.PEN);
}

//  LCD̕\AhXݒ

void lcd_ddram(unsigned char ads){
    lcd_cmd(0x80 | ads);
    Delay10TCYx( 43);  //  26.3s/(64MHz/4)=  430
}

//  LCDɕ\

void lcd_puts(const char* buf){
    char* p=buf;
    while(*p){
        if(*p=='\n')
            lcd_ddram(0x40);   //2s
        else{
           lcd_data(*p);
            Delay10TCYx( 43);  //  26.3s*(64MHz/4)=  430
        }
        ++p;
    }
}

